<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.stanzaprocessor.StanzaProcessor</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.stanzaprocessor-module.html">Module&nbsp;stanzaprocessor</a> ::
        Class&nbsp;StanzaProcessor
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class StanzaProcessor</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor">source&nbsp;code</a></span></p>
<dl><dt>Known Subclasses:</dt>
<dd>
      <ul class="subclass-list">
<li><a href="pyxmpp.streambase.StreamBase-class.html">streambase.StreamBase</a></li>  </ul>
</dd></dl>

<hr />
<p>Universal stanza handler/router class.</p>
<p>Provides facilities to set up custom handlers for various types of stanzas.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#__add_handler" class="summary-sig-name" onclick="show_private();">__add_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">handler_list</span>,
        <span class="summary-sig-arg">typ</span>,
        <span class="summary-sig-arg">namespace</span>,
        <span class="summary-sig-arg">priority</span>,
        <span class="summary-sig-arg">handler</span>)</span><br />
      Add a handler function to a prioritized handler list.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.__add_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__init__"></a><span class="summary-sig-name">__init__</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Initialize a <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html" class="link">StanzaProcessor</a> object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#__try_handlers" class="summary-sig-name" onclick="show_private();">__try_handlers</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">handler_list</span>,
        <span class="summary-sig-arg">typ</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Search the handler list for handlers matching
given stanza type and payload namespace.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.__try_handlers">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_set_response_handlers"></a><span class="summary-sig-name">_set_response_handlers</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">iq</span>,
        <span class="summary-sig-arg">res_handler</span>,
        <span class="summary-sig-arg">err_handler</span>,
        <span class="summary-sig-arg">timeout_handler</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">timeout</span>=<span class="summary-sig-default">300</span>)</span><br />
      Same as <code class="link">Stream.set_response_handlers</code> but assume <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor._set_response_handlers">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#check_to" class="summary-sig-name">check_to</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">to</span>)</span><br />
      Check &quot;to&quot; attribute of received stream header.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.check_to">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_in_stanza" class="summary-sig-name">fix_in_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Modify incoming stanza before processing it.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.fix_in_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_out_stanza" class="summary-sig-name">fix_out_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Modify outgoing stanza before sending into the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.fix_out_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_iq" class="summary-sig-name">process_iq</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Process IQ stanza received.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_iq">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_message" class="summary-sig-name">process_message</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Process message stanza.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_message">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_presence" class="summary-sig-name">process_presence</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Process presence stanza.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_presence">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">bool</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_response" class="summary-sig-name">process_response</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">response</span>)</span><br />
      Examines out the response returned by a stanza handler and sends all
stanzas provided.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_response">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_stanza" class="summary-sig-name">process_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Process stanza received from the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#route_stanza" class="summary-sig-name">route_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Process stanza not addressed to us.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.route_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#send" class="summary-sig-name">send</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Send a stanza somwhere.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.send">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_get_handler" class="summary-sig-name">set_iq_get_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">element</span>,
        <span class="summary-sig-arg">namespace</span>,
        <span class="summary-sig-arg">handler</span>)</span><br />
      Set &lt;iq type=&quot;get&quot;/&gt; handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_iq_get_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_set_handler" class="summary-sig-name">set_iq_set_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">element</span>,
        <span class="summary-sig-arg">namespace</span>,
        <span class="summary-sig-arg">handler</span>)</span><br />
      Set &lt;iq type=&quot;set&quot;/&gt; handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_iq_set_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_message_handler" class="summary-sig-name">set_message_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">typ</span>,
        <span class="summary-sig-arg">handler</span>,
        <span class="summary-sig-arg">namespace</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">priority</span>=<span class="summary-sig-default">100</span>)</span><br />
      Set a handler for &lt;message/&gt; stanzas.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_message_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_presence_handler" class="summary-sig-name">set_presence_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">typ</span>,
        <span class="summary-sig-arg">handler</span>,
        <span class="summary-sig-arg">namespace</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">priority</span>=<span class="summary-sig-default">100</span>)</span><br />
      Set a handler for &lt;presence/&gt; stanzas.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_presence_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_response_handlers" class="summary-sig-name">set_response_handlers</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">iq</span>,
        <span class="summary-sig-arg">res_handler</span>,
        <span class="summary-sig-arg">err_handler</span>,
        <span class="summary-sig-arg">timeout_handler</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">timeout</span>=<span class="summary-sig-default">300</span>)</span><br />
      Set response handler for an IQ &quot;get&quot; or &quot;set&quot; stanza.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_response_handlers">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_get_handler" class="summary-sig-name">unset_iq_get_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">element</span>,
        <span class="summary-sig-arg">namespace</span>)</span><br />
      Remove &lt;iq type=&quot;get&quot;/&gt; handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.unset_iq_get_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_set_handler" class="summary-sig-name">unset_iq_set_handler</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">element</span>,
        <span class="summary-sig-arg">namespace</span>)</span><br />
      Remove &lt;iq type=&quot;set&quot;/&gt; handler.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.unset_iq_set_handler">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE VARIABLES ==================== -->
<a name="section-InstanceVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="initiator"></a><span class="summary-name">initiator</span><br />
      : <code class="link">True</code> if local stream endpoint is the initiating entity.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="lock"></a><span class="summary-name">lock</span><br />
      : lock object used to synchronize access to the
<a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html" class="link">StanzaProcessor</a> object.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="me"></a><span class="summary-name">me</span><br />
      : local JID.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="peer"></a><span class="summary-name">peer</span><br />
      : remote stream endpoint JID.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="process_all_stanzas"></a><span class="summary-name">process_all_stanzas</span><br />
      : when <code class="link">True</code> then all stanzas received are
considered local.
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__add_handler"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__add_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">handler_list</span>,
        <span class="sig-arg">typ</span>,
        <span class="sig-arg">namespace</span>,
        <span class="sig-arg">priority</span>,
        <span class="sig-arg">handler</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.__add_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Add a handler function to a prioritized handler list.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>handler_list</code></strong> - : a handler list.</li>
        <li><strong class="pname"><code>typ</code></strong> - : stanza type.</li>
        <li><strong class="pname"><code>namespace</code></strong> - : stanza payload namespace.</li>
        <li><strong class="pname"><code>priority</code></strong> - : handler priority. Must be &gt;=0 and &lt;=100. Handlers
with lower priority list will be tried first.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="__try_handlers"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__try_handlers</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">handler_list</span>,
        <span class="sig-arg">typ</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.__try_handlers">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Search the handler list for handlers matching
given stanza type and payload namespace. Run the
handlers found ordering them by priority until
the first one which returns <code class="link">True</code>.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>handler_list</code></strong> - : list of available handlers</li>
        <li><strong class="pname"><code>typ</code></strong> - : stanza type (value of its &quot;type&quot; attribute)</li>
        <li><strong class="pname"><code>stanza</code></strong> - : the stanza to handle</li>
    </ul></dd>
    <dt>Returns:</dt>
        <dd>result of the last handler or <code class="link">False</code> if no
handler was found.</dd>
  </dl>
</td></tr></table>
</div>
<a name="check_to"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">check_to</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">to</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.check_to">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Check &quot;to&quot; attribute of received stream header.</p>
<p>Should be overriden in derived classes which require other logic
for handling that attribute.</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd><code class="link">to</code> if it is equal to <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#me" class="link">self.me</a>, None otherwise.</dd>
  </dl>
</td></tr></table>
</div>
<a name="fix_in_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fix_in_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.fix_in_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Modify incoming stanza before processing it.</p>
<p>This implementation does nothig. It should be overriden in derived
classes if needed.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="fix_out_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fix_out_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.fix_out_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Modify outgoing stanza before sending into the stream.</p>
<p>This implementation does nothig. It should be overriden in derived
classes if needed.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="process_iq"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_iq</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_iq">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process IQ stanza received.</p>
<p>If a matching handler is available pass the stanza to it.
Otherwise ignore it if it is &quot;error&quot; or &quot;result&quot; stanza
or return &quot;feature-not-implemented&quot; error.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : the stanza received</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="process_message"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_message</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_message">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process message stanza.</p>
<p>Pass it to a handler of the stanza's type and payload namespace.
If no handler for the actual stanza type succeeds then hadlers
for type &quot;normal&quot; are used.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : message stanza to be handled</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="process_presence"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_presence</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_presence">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process presence stanza.</p>
<p>Pass it to a handler of the stanza's type and payload namespace.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : presence stanza to be handled</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="process_response"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_response</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">response</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_response">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Examines out the response returned by a stanza handler and sends all
stanzas provided.
  <dl class="fields">
    <dt>Returns: <code class="link">bool</code></dt>
        <dd><ul class="rst-simple">
<li><code class="link">True</code>: if <code class="link">response</code> is <a href="pyxmpp.stanza.Stanza-class.html" class="link">Stanza</a>, iterable or <code class="link">True</code> (meaning the stanza was processed).</li>
<li><code class="link">False</code>: when <code class="link">response</code> is <code class="link">False</code> or <code class="link">None</code></li>
</ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="process_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.process_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process stanza received from the stream.</p>
<p>First &quot;fix&quot; the stanza with <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_in_stanza" class="link">self.fix_in_stanza()</a>,
then pass it to <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#route_stanza" class="link">self.route_stanza()</a> if it is not directed
to <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#me" class="link">self.me</a> and <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_all_stanzas" class="link">self.process_all_stanzas</a> is not True. Otherwise
stanza is passwd to <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_iq" class="link">self.process_iq()</a>, <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_message" class="link">self.process_message()</a>
or <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_presence" class="link">self.process_presence()</a> appropriately.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : the stanza received.</li>
    </ul></dd>
    <dt>Returns:</dt>
        <dd><code class="link">True</code> when stanza was handled</dd>
  </dl>
</td></tr></table>
</div>
<a name="route_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">route_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.route_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process stanza not addressed to us.</p>
<p>Return &quot;recipient-unavailable&quot; return if it is not
&quot;error&quot; nor &quot;result&quot; stanza.</p>
<p>This method should be overriden in derived classes if they
are supposed to handle stanzas not addressed directly to local
stream endpoint.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : presence stanza to be processed</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="send"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">send</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.send">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Send a stanza somwhere. This one does nothing. Should be overriden
in derived classes.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> (: <a href="pyxmpp.stanza.Stanza-class.html" class="link">pyxmpp.stanza.Stanza</a>) - : the stanza to send.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="set_iq_get_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">set_iq_get_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">element</span>,
        <span class="sig-arg">namespace</span>,
        <span class="sig-arg">handler</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_iq_get_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Set &lt;iq type=&quot;get&quot;/&gt; handler.</p>
<p>Only one handler may be defined per one namespaced element.
If a handler for the element was already set it will be lost
after calling this method.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>element</code></strong> - : payload element name</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload element namespace URI</li>
        <li><strong class="pname"><code>handler</code></strong> - : function to be called when a stanza
with defined element is received. Its only argument
will be the stanza received. The handler may return a stanza or
list of stanzas which should be sent in response.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="set_iq_set_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">set_iq_set_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">element</span>,
        <span class="sig-arg">namespace</span>,
        <span class="sig-arg">handler</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_iq_set_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Set &lt;iq type=&quot;set&quot;/&gt; handler.</p>
<p>Only one handler may be defined per one namespaced element.
If a handler for the element was already set it will be lost
after calling this method.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>element</code></strong> - : payload element name</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload element namespace URI</li>
        <li><strong class="pname"><code>handler</code></strong> - : function to be called when a stanza
with defined element is received. Its only argument
will be the stanza received. The handler may return a stanza or
list of stanzas which should be sent in response.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="set_message_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">set_message_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">typ</span>,
        <span class="sig-arg">handler</span>,
        <span class="sig-arg">namespace</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">priority</span>=<span class="sig-default">100</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_message_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Set a handler for &lt;message/&gt; stanzas.</p>
<p>Multiple &lt;message /&gt; handlers with the same type/namespace/priority may
be set. Order of calling handlers with the same priority is not defined.
Handlers will be called in priority order until one of them returns True or
any stanza(s) to send (even empty list will do).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>typ</code></strong> - : message type. <code class="link">None</code> will be treated the same as &quot;normal&quot;,
and will be the default for unknown types (those that have no
handler associated).</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload namespace. If <code class="link">None</code> that message with any
payload (or even with no payload) will match.</li>
        <li><strong class="pname"><code>priority</code></strong> - : priority value for the handler. Handlers with lower
priority value are tried first.</li>
        <li><strong class="pname"><code>handler</code></strong> - : function to be called when a message stanza
with defined type and payload namespace is received. Its only
argument will be the stanza received. The handler may return a
stanza or list of stanzas which should be sent in response.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="set_presence_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">set_presence_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">typ</span>,
        <span class="sig-arg">handler</span>,
        <span class="sig-arg">namespace</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">priority</span>=<span class="sig-default">100</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_presence_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Set a handler for &lt;presence/&gt; stanzas.</p>
<p>Multiple &lt;presence /&gt; handlers with the same type/namespace/priority may
be set. Order of calling handlers with the same priority is not defined.
Handlers will be called in priority order until one of them returns
True or any stanza(s) to send (even empty list will do).</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>typ</code></strong> - : presence type. &quot;available&quot; will be treated the same as <code class="link">None</code>.</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload namespace. If <code class="link">None</code> that presence with any
payload (or even with no payload) will match.</li>
        <li><strong class="pname"><code>priority</code></strong> - : priority value for the handler. Handlers with lower
priority value are tried first.</li>
        <li><strong class="pname"><code>handler</code></strong> - : function to be called when a presence stanza
with defined type and payload namespace is received. Its only
argument will be the stanza received. The handler may return a
stanza or list of stanzas which should be sent in response.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="set_response_handlers"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">set_response_handlers</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">iq</span>,
        <span class="sig-arg">res_handler</span>,
        <span class="sig-arg">err_handler</span>,
        <span class="sig-arg">timeout_handler</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">timeout</span>=<span class="sig-default">300</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.set_response_handlers">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Set response handler for an IQ &quot;get&quot; or &quot;set&quot; stanza.</p>
<p>This should be called before the stanza is sent.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>iq</code></strong> - : an IQ stanza</li>
        <li><strong class="pname"><code>res_handler</code></strong> - : result handler for the stanza. Will be called
when matching &lt;iq type=&quot;result&quot;/&gt; is received. Its only
argument will be the stanza received. The handler may return
a stanza or list of stanzas which should be sent in response.</li>
        <li><strong class="pname"><code>err_handler</code></strong> - : error handler for the stanza. Will be called
when matching &lt;iq type=&quot;error&quot;/&gt; is received. Its only
argument will be the stanza received. The handler may return
a stanza or list of stanzas which should be sent in response
but this feature should rather not be used (it is better not to
respond to 'error' stanzas).</li>
        <li><strong class="pname"><code>timeout_handler</code></strong> - : timeout handler for the stanza. Will be called
when no matching &lt;iq type=&quot;result&quot;/&gt; or &lt;iq type=&quot;error&quot;/&gt; is
received in next <code class="link">timeout</code> seconds. The handler should accept
two arguments and ignore them.</li>
        <li><strong class="pname"><code>timeout</code></strong> - : timeout value for the stanza. After that time if no
matching &lt;iq type=&quot;result&quot;/&gt; nor &lt;iq type=&quot;error&quot;/&gt; stanza is
received, then timeout_handler (if given) will be called.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="unset_iq_get_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">unset_iq_get_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">element</span>,
        <span class="sig-arg">namespace</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.unset_iq_get_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Remove &lt;iq type=&quot;get&quot;/&gt; handler.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>element</code></strong> - : payload element name</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload element namespace URI</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="unset_iq_set_handler"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">unset_iq_set_handler</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">element</span>,
        <span class="sig-arg">namespace</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.stanzaprocessor-pysrc.html#StanzaProcessor.unset_iq_set_handler">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Remove &lt;iq type=&quot;set&quot;/&gt; handler.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>element</code></strong> - : payload element name.</li>
        <li><strong class="pname"><code>namespace</code></strong> - : payload element namespace URI.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:05 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
